#!/usr/bin/env python
# Copyright (C) 2012-2015 Shun Sakuraba
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version. See LICENSE file for details.

import sys
import os
import os.path
import shutil
import math
import collections
import copy

import popen2
from optparse import OptionParser

parser = OptionParser()

# topology, mandatory
parser.add_option("-t", "--top", dest = "topology",
                  help = "Gromacs topology file (*.top)",
                  default = None)
parser.add_option("-O", "--output", dest = "output",
                  help = "output Gromacs topology file",
                  default = None)
parser.add_option("-v", "--verbose", dest = "verbose", action = "store_true",
                  help = "Increase verbosity (for debug)",
                  default = False)

(options, args) = parser.parse_args()

def log(x):
    if options.verbose:
        print >> sys.stderr, x

def warn_or_error(x, col):
    prefix = ""
    suffix = ""
    if os.isatty(sys.stderr.fileno()):
        prefix = "\x1b[" + str(col) + ";1m"
        suffix = "\x1b[0m"
    print >> sys.stderr, prefix + x + suffix

def warn(x):
    warn_or_error("Warning: " + x, 33)

def error(x):
    warn_or_error("Error: " + x, 31)
    sys.exit(1)

if options.topology == None:
    error("topology must be specified (try --help)")

state = None

with open(options.topology, "r") as fh, (
     open(options.output, "w")) as ofh:
    ofh.write("; Generated by %s\n" % " ".join(sys.argv))
    for l in fh:
        lsp = l.split(";", 1) 
        if len(lsp) == 1:
            contents = lsp[0]
            comment = ""
        else:
            [contents, comment] = lsp
        contents = contents.strip()
        if contents == "":
            ofh.write(l)
            continue
        if contents[0] == "[":
            state = contents.split()[1]
            ofh.write(l)
            continue
        ls = contents.split()
        if state == "atoms":
# TODO
            ls = contents.split()
            if len(ls) == 8:
                ofh.write(l)
                continue
            elif len(ls) == 11:
                # A-B state, copy last 3 to A
                newstate = ls[0:8]
                (ATOMTYPE, CHARGE, MASS) = (1, 6, 7)
                (ATOMTYPEB, CHARGEB, MASSB) = (8, 9, 10)
                newstate[ATOMTYPE] = ls[ATOMTYPEB]
                newstate[CHARGE] = ls[CHARGEB]
                newstate[MASS] = ls[MASSB]
                ofh.write("\t".join(newstate) + "\n")
                continue
            else:
                error("FIXME: Need to implement length check in [ atoms ] section")
        elif state == "bonds":
            atoms = ls[0:3]
            # func = ls[3]
            # FIXME
            ofh.write(l)
        elif state == "angles":
            atoms = ls[0:3]
            # func = ls[3]
            # FIXME
            ofh.write(l)
        elif state == "dihedrals":
            atoms = ls[0:4]
            func = int(ls[4])
            factors = { 1: (3, 3),
                        2: (2, 2),
                        4: (3, 3),
                        9: (3, 3) } #FIXME
            if func not in factors:
                error("FIXME: dihedral type %d not registered" % func)
            (paramA, paramB) = factors[func]
            offset = 5
            if len(ls) == offset:
                ofh.write(l)
            elif len(ls) == offset + paramA:
                ofh.write(l)
            elif len(ls) == offset + paramA + paramB:
                ls[offset:(offset + paramA)] = ls[(offset + paramA):(offset + paramA + paramB)]
                ofh.write("\t".join(ls[0:(offset + paramA)]) + "\n")
            else:
                error("FIXME: unsupported line: \"%s\"" % l)
        else:
            ofh.write(l)

